#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>

#include <X11/Intrinsic.h>

#include "lirc_client.h"
#include "lirc_tv.h"
#include "channel.h"

/*-----------------------------------------------------------------------*/

extern int debug;

static struct lirc_config *config;

int lirc_tv_init()
{
    int fd;
    
    if (-1 == (fd = lirc_init("xawtv"))) {
	fprintf(stderr,"no infrared remote support available\n");
	return -1;
    }
    
    if (0 != lirc_readconfig(NULL,&config,NULL)) {
	lirc_deinit();
	return -1;
    }
    fcntl(fd,F_SETFL,O_NONBLOCK);
    fcntl(fd,F_SETFD,FD_CLOEXEC);
    
    return fd;
}

int lirc_tv_havedata()
{
    char *ir,*cmd,**argv;
    int argc;
    
    while (NULL != (ir = lirc_nextir())) {
	while (NULL != (cmd = lirc_ir2char(config,ir))) {
	    if (debug)
		fprintf(stderr,"lirc: \"%s\"\n", cmd);
	    argv = split_cmdline(cmd,&argc);
	}
	free(ir);
    }
    return 0;
}
